##
## cups (browse) - to see other printers
## 

class cups::browse {

    package { [ 'cups' ]: ensure => installed }

    file { "/etc/cups/cupsd.conf": ensure => present, checksum => mtime }
    
    line { cupsbrowseoff:
       file => "/etc/cups/cupsd.conf",
       line => 'Browsing Off',
       ensure => absent,
       require => Package["cups"]
    }
    line { cupsbrowseon:
       file => "/etc/cups/cupsd.conf",
       line => 'Browsing On',
       ensure => present,
       require => Package["cups"]
    }

    service { "cups":
       enable => true,
       ensure => running,
       subscribe => [ Package["cups"], File["/etc/cups/cupsd.conf"] ],
    }
}
